'''combat
'''

import random

class Arena(object):
    def __init__(self):
        self.seconds_per_round = 0.5
        self.cooldown = 0.0

    def update_combat_cooldown(self, dt):
        self.cooldown -= dt
        if self.cooldown < 0:
            self.cooldown = 0.0

    def combat_round(self, player, monster, printconsole):
        if self.cooldown > 0:
            return
        # Roll for initiative
        roll = random.random()
        if roll > 0.5:
            monster.combat.attacked_by(player.combat, printconsole)
            player.combat.attacked_by(monster.combat, printconsole)
        else:
            player.combat.attacked_by(monster.combat, printconsole)
            monster.combat.attacked_by(player.combat, printconsole)
        self.cooldown = self.seconds_per_round


class Combat(object):
    def __init__(self, name = 'Unknown',
                 damage_points = 100, attack_power = 10,
                 attack_rating = 10, defense_rating = 10):
        self.name = name
        self.damage_points = damage_points
        self.max_damage_points = damage_points
        self.attack_power = attack_power
        self.attack_rating = attack_rating
        self.defense_rating = defense_rating

    def attacked_by(self, attacker, printconsole):
        success = 0.5 + 0.1 * (attacker.attack_rating - self.defense_rating)
        if success < 0.01:
            success = 0.01
        if success > 0.99:
            success = 0.99
        roll = random.random()
        if roll < success:
            damage = attacker.attack_power
            self.damage_points -= damage
            printconsole("%s hits %s for %d points!" % (attacker.name,
                                                        self.name, damage))
        else:
            printconsole("%s misses!" % attacker.name)
