'''level exit
'''

import pyglet
import pymunk
import spritesheet
from spritesheet import spritesheet
import misc

class ExitDoor(object):
    def __init__(self, g, x, y):
        img = spritesheet['doorwall'][24]
        img.width = 200
        img.height = 200
        self.sprite = pyglet.sprite.Sprite(img, x, y)
        x2 = x + img.width
        y2 = y + img.width
        self.body = pymunk.Body(pymunk.inf, pymunk.inf)
        self.shape = pymunk.Poly(self.body,
                                 [(x, y), (x, y2), (x2, y2), (x2, y)],
                                 (0,0))
        self.shape.collision_type = misc.COLLTYPE_EXIT
        g.space.add(self.shape)
        self.x = x
        self.y = y


    def draw(self):
        self.sprite.draw()


def collision(a, b, contacts, normal, g):
    '''Collision function for collision between player and item
    '''
    if a.collision_type == misc.COLLTYPE_EXIT:
        itemshape = a
    elif b.collision_type == misc.COLLTYPE_EXIT:
        itemshape = b
    else:
        # this should never happen
        print "didn't find item"
        return True
    targetitem = 0
    for item in g.exitlist:
        if item.shape == itemshape:
            targetitem = item
    if targetitem:
        g.gamestate = 'winscreen'
        g.gui.printconsole("YOU JUST WON THE GAME!")
    return True


