'''Graphical user interface
'''

from pyglet.gl import *

class GuiPanel(object):
    def __init__(self, win):
        # inv 250 px
        # equip 50 px
        # infotext 100 px
        # console below
        self.pix_x = 100
        self.pix_y = 400
        self.win = win
        #self.label = pyglet.text.Label(text = 'GUI', font_size = 18,
        #                               x = 10, y = 300, anchor_x = 'left',
        #                               color = (255,255,255,255))
        self.console = pyglet.text.document.UnformattedDocument( 
            'Snake RPG\n')
        self.console.set_style(0, 1, dict(color = (255,255,255,255),
                                          font_size = 8))
        self.console_layout = pyglet.text.layout.IncrementalTextLayout( \
            self.console, 200, win.height - self.pix_y, multiline=True)
        self.console_layout.x = 0
        self.console_layout.y = 0
        self.console_layout.anchor_x = 'left'
        self.console_layout.anchor_y = 'top'
        self.paperdoll = pyglet.sprite.Sprite( \
            pyglet.resource.image('paperdoll.png'),
            x = 0, y = 75)
        self.dp_label = pyglet.text.Label(text = "Scales:\n%d" % 100,
                                          font_size = 12, width = 100,
                                          multiline = True,
                                          x = 0, y = 50)
        self.ap_label = pyglet.text.Label(text = "Bite: %d" % 10,
                                          font_size = 12, x = 0,
                                          y = 15)

    def resize(self):
        self.console_layout.height = self.win.height - self.pix_y
        self.console_layout.view_y = -99999

    def printconsole(self, text):
        self.console.insert_text(len(self.console.text),text + "\n")
        self.console_layout.view_y = -99999

    def draw(self):
        self.dp_label.text = "Scales:\n%d / %d" % \
                             (self.win.g.player.combat.damage_points,
                              self.win.g.player.combat.max_damage_points)
        self.ap_label.text = "Bite: %d" % \
                             self.win.g.player.combat.attack_power
        x1 = 0
        y1 = self.win.height - self.pix_y
        x2 = self.pix_x
        y2 = self.win.height
        # Set up screen mode
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        glOrtho(0, self.win.width, 0, self.win.height, -1, 1)
        glMatrixMode(GL_MODELVIEW)
        # Draw gui
        glLoadIdentity()
        glTranslatef(0.0, self.win.height - self.pix_y, 0.0)
        glColor3f(0.0,0.0,1.0)
        glBegin(GL_QUADS)
        glVertex2f(0, 0)
        glVertex2f(self.pix_x, 0)
        glVertex2f(self.pix_x, self.pix_y)
        glVertex2f(0, self.pix_y)
        glEnd()
        self.win.g.inventory.draw()
        self.paperdoll.draw()
        self.dp_label.draw()
        self.ap_label.draw()
        self.console_layout.draw()
        glTranslatef(self.pix_x, 0.0, 0.0)
        self.win.fps_display.draw()
        # reset to game world mode
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        gluPerspective(60.0, self.win.width / float(self.win.height),
                       self.win.g.nearclip, self.win.g.farclip)
        glMatrixMode(GL_MODELVIEW)

